﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_array_copy_2d_array
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string[,] Values2d;

        // Initialize the values.
        private void Form1_Load(object sender, EventArgs e)
        {
            Values2d = new string[5, 4];
            for (int row = 0; row <= Values2d.GetUpperBound(0); row++)
            {
                for (int col = 0; col <= Values2d.GetUpperBound(1); col++)
                {
                    Values2d[row, col] = "(" + row.ToString() + ", " + col.ToString() + ")";
                }
            }

            // Display the values.
            ShowValues(lstValues, Values2d);
        }

        // Copy the values and display the result.
        private void btnCopy2d_Click(object sender, EventArgs e)
        {
            string[,] new_values = new string[3, 3];
            for (int row = 0; row <= new_values.GetUpperBound(0); row++)
            {
                for (int col = 0; col <= new_values.GetUpperBound(1); col++)
                {
                    new_values[row, col] = "------";
                }
            }

            Array.Copy(Values2d, 6, new_values, 2, 6);
            ShowValues(lstCopy, new_values);
        }

        // Display some values in a ListBox.
        private void ShowValues(ListBox lst, string[,] the_values)
        {
            lst.Items.Clear();
            for (int row = 0; row <= the_values.GetUpperBound(0); row++)
            {
                string str = "";
                for (int col = 0; col <= the_values.GetUpperBound(1); col++)
                {
                    str += the_values[row, col] + " ";
                }
                str = str.Substring(0, str.Length - 1);
                lst.Items.Add(str);
            }
        }
    }
}
